# This a copy of the pulumi example to deploy an API gateway

[![Deploy](https://get.pulumi.com/new/button.svg)](https://app.pulumi.com/new)

# Serverless REST API on AWS

A simple REST API that counts the number of times a route has been hit. For a detailed walkthrough of this example, see the article [Create a Serverless REST API](https://pulumi.io/quickstart/aws-rest-api.html).

## Deploying and running the program

Note: some values in this example will be different from run to run.  These values are indicated
with `***`.

1.  Create a new stack:

    ```bash
    $ pulumi stack init dev
    ```

1.  Set the AWS region:

    ```
    $ pulumi config set aws:region eu-west-2
    ```

1.  Restore NPM modules via `npm install` or `yarn install`.

1.  Run `pulumi up` to preview and deploy changes:

    ```
    $ pulumi up
    Previewing update of stack 'dev'
    ...

    Updating (count-api-testing):

         Type                                Name                                 Status      
     +   pulumi:pulumi:Stack                 aws-ts-apigateway-count-api-testing  created     
     +   ├─ aws:apigateway:x:API             hello-world                          created     
     +   │  ├─ aws:iam:Role                  hello-world4fcc7b60                  created     
     +   │  ├─ aws:iam:RolePolicyAttachment  hello-world4fcc7b60-32be53a2         created     
     +   │  ├─ aws:lambda:Function           hello-world4fcc7b60                  created     
     +   │  ├─ aws:apigateway:RestApi        hello-world                          created     
     +   │  ├─ aws:apigateway:Deployment     hello-world                          created     
     +   │  ├─ aws:lambda:Permission         hello-world-a552609d                 created     
     +   │  └─ aws:apigateway:Stage          hello-world                          created     
     +   └─ aws:dynamodb:Table               counterTable                         created     

    Outputs:
        endpoint: "https://***execute-api.us-east-2.amazonaws.com/stage/"

    Resources:
        + 10 created

    Duration: 24s
    ```

1.  View the endpoint URL and curl a few routes:

    ```bash
    $ pulumi stack output
    Current stack outputs (1):
        OUTPUT            VALUE
        endpoint          https://***.eu-west-xx.amazonaws.com/stage/

    $ curl $(pulumi stack output endpoint)/hello
    {"route":"hello","count":1}
    $ curl $(pulumi stack output endpoint)/hello
    {"route":"hello","count":2}
    $ curl $(pulumi stack output endpoint)/woohoo
    {"route":"woohoo","count":1}
    ```

1.  To view the runtime logs of the Lambda function, use the `pulumi logs` command. To get a log stream, use `pulumi logs --follow`.

## Clean up

1.  Run `pulumi destroy` to tear down all resources.

1.  To delete the stack itself, run `pulumi stack rm`. Note that this command deletes all deployment history from the Pulumi Console.
